'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./dispatcher'),
    dispatch = _require.dispatch;

var readHandlerResult = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(res) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', res);

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function readHandlerResult(_x) {
    return _ref.apply(this, arguments);
  };
}();

var callHandler = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(handler, args) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', readHandlerResult(handler.apply(undefined, (0, _toConsumableArray3.default)(args))));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function callHandler(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var createTransactions = function createTransactions(sources) {
  return sources.map(function (source) {
    return source.objects.createTransaction();
  });
};
var commitTransactions = function commitTransactions(sources) {
  return sources.map(function (source) {
    return source.objects.commitTransaction();
  });
};

var callHandlerAndCommit = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(handler, sources, args) {
    var res;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return callHandler(handler, args);

          case 2:
            res = _context3.sent;


            commitTransactions(sources);
            return _context3.abrupt('return', res);

          case 5:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function callHandlerAndCommit(_x4, _x5, _x6) {
    return _ref3.apply(this, arguments);
  };
}();

var packAction = function packAction(handler) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var sources = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            createTransactions(sources);
            return _context4.abrupt('return', callHandlerAndCommit(handler, sources, args));

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));
};

var createAction = function createAction(handler) {
  var sources = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var action;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            action = packAction(handler, args, sources);
            return _context5.abrupt('return', dispatch(action, sources));

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));
};

module.exports = {
  readHandlerResult: readHandlerResult,
  callHandler: callHandler,
  createTransactions: createTransactions,
  commitTransactions: commitTransactions,
  callHandlerAndCommit: callHandlerAndCommit,
  createAction: createAction,
  packAction: packAction
};
