'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var extendWithField = function extendWithField(_ref) {
  var EntryConstructor = _ref.EntryConstructor,
      field = _ref.field;
  return function (_EntryConstructor) {
    (0, _inherits3.default)(_class, _EntryConstructor);

    function _class() {
      var _ref2;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      (0, _classCallCheck3.default)(this, _class);

      var _this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref2, [this].concat(args)));

      if (!_this.values.has(field.name) && field.init) {
        _this[field.name] = field.init ? field.init({ entry: _this, args: args }) : null;
      }
      return _this;
    }

    (0, _createClass3.default)(_class, [{
      key: field.name,
      set: function set(value) {
        this.values = field.set ? field.set({ entry: this, set: (0, _get3.default)(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'set', this), value: value }) : null;
      },
      get: function get() {
        return field.get ? field.get({ entry: this, get: (0, _get3.default)(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'get', this) }) : null;
      }
    }]);
    return _class;
  }(EntryConstructor);
};

var createWithField = function createWithField(name, proto) {
  return function (_ref3) {
    var setup = _ref3.setup;
    return setup.set('EntryConstructor', extendWithField({
      EntryConstructor: setup.get('EntryConstructor'),
      field: Object.assign({ name: name }, proto)
    }));
  };
};

var withInitializedField = function withInitializedField(name, _ref4) {
  var _ref4$initial = _ref4.initial,
      initial = _ref4$initial === undefined ? null : _ref4$initial;
  return createWithField(name, {
    init: function init() {
      return initial;
    },
    set: function set(_ref5) {
      var entry = _ref5.entry,
          value = _ref5.value;
      return entry.values.set(name, value);
    },
    get: function get(_ref6) {
      var entry = _ref6.entry;
      return entry.values.get(name);
    }
  });
};

var withField = function withField(name) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return withInitializedField(name, options);
};

module.exports = {
  extendWithField: extendWithField,
  createWithField: createWithField,
  withField: withField
};
