'use strict';

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sortBy = require('sort-by');

var REVERSED = 1;

/*
 * Filter
 */

var createFilterPredicate = function createFilterPredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] === expression[key];
    });
  };
};

var getFilterPredicate = function getFilterPredicate(expression) {
  return typeof expression === 'function' ? expression : createFilterPredicate(expression);
};

/*
 * Exclude
 */

var createExcludePredicate = function createExcludePredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] !== expression[key];
    });
  };
};

var getExcludePredicate = function getExcludePredicate(expression) {
  return typeof expression === 'function' ? expression : createExcludePredicate(expression);
};

/*
 * Mixin
 */

var SortedEntriesGenerator = function () {
  function SortedEntriesGenerator(queryset, sortComparator) {
    (0, _classCallCheck3.default)(this, SortedEntriesGenerator);

    this.sortComparator = sortComparator;
    this.parent = queryset.parent;
  }

  (0, _createClass3.default)(SortedEntriesGenerator, [{
    key: 'entries',
    value: _regenerator2.default.mark(function entries() {
      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, entry;

      return _regenerator2.default.wrap(function entries$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 3;
              _iterator = this.parent.toArray().sort(this.sortComparator).entries()[Symbol.iterator]();

            case 5:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context.next = 12;
                break;
              }

              _step$value = (0, _slicedToArray3.default)(_step.value, 2), entry = _step$value[1];
              _context.next = 9;
              return entry;

            case 9:
              _iteratorNormalCompletion = true;
              _context.next = 5;
              break;

            case 12:
              _context.next = 18;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context['catch'](3);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 18:
              _context.prev = 18;
              _context.prev = 19;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 21:
              _context.prev = 21;

              if (!_didIteratorError) {
                _context.next = 24;
                break;
              }

              throw _iteratorError;

            case 24:
              return _context.finish(21);

            case 25:
              return _context.finish(18);

            case 26:
            case 'end':
              return _context.stop();
          }
        }
      }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
    })
  }]);
  return SortedEntriesGenerator;
}();

var withNonEntriesGenerator = function withNonEntriesGenerator(Base) {
  return function (_Base) {
    (0, _inherits3.default)(_class, _Base);

    function _class() {
      var _ref;

      (0, _classCallCheck3.default)(this, _class);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args)));

      _this.source = [];
      return _this;
    }

    return _class;
  }(Base);
};

var withQueries = function withQueries(Base) {
  return function (_Base2) {
    (0, _inherits3.default)(_class2, _Base2);

    function _class2(_ref2) {
      var QuerySetConstructor = _ref2.QuerySetConstructor,
          _ref2$parent = _ref2.parent,
          parent = _ref2$parent === undefined ? null : _ref2$parent,
          _ref2$predicate = _ref2.predicate,
          predicate = _ref2$predicate === undefined ? null : _ref2$predicate,
          _ref2$sortComparator = _ref2.sortComparator,
          sortComparator = _ref2$sortComparator === undefined ? null : _ref2$sortComparator;
      (0, _classCallCheck3.default)(this, _class2);

      var _this2 = (0, _possibleConstructorReturn3.default)(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).call(this, { parent: parent, QuerySetConstructor: QuerySetConstructor }));

      _this2.predicate = predicate;
      _this2.source = sortComparator ? new SortedEntriesGenerator(_this2, sortComparator) : null;
      return _this2;
    }

    (0, _createClass3.default)(_class2, [{
      key: 'validate',
      value: function validate(entry) {
        return !this.predicate || this.predicate(entry);
      }
    }, {
      key: 'getFallbackSource',
      value: function getFallbackSource() {
        var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

        return source || this.parent;
      }
    }, {
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var source, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, entry;

        return _regenerator2.default.wrap(function entries$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                source = this.getFallbackSource(this.source);
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context2.prev = 4;
                _iterator2 = source.entries()[Symbol.iterator]();

              case 6:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context2.next = 14;
                  break;
                }

                entry = _step2.value;

                if (!this.validate(entry)) {
                  _context2.next = 11;
                  break;
                }

                _context2.next = 11;
                return entry;

              case 11:
                _iteratorNormalCompletion2 = true;
                _context2.next = 6;
                break;

              case 14:
                _context2.next = 20;
                break;

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2['catch'](4);
                _didIteratorError2 = true;
                _iteratorError2 = _context2.t0;

              case 20:
                _context2.prev = 20;
                _context2.prev = 21;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 23:
                _context2.prev = 23;

                if (!_didIteratorError2) {
                  _context2.next = 26;
                  break;
                }

                throw _iteratorError2;

              case 26:
                return _context2.finish(23);

              case 27:
                return _context2.finish(20);

              case 28:
              case 'end':
                return _context2.stop();
            }
          }
        }, entries, this, [[4, 16, 20, 28], [21,, 23, 27]]);
      })
    }, {
      key: 'filter',
      value: function filter(expression) {
        return this.clone({ predicate: getFilterPredicate(expression) });
      }
    }, {
      key: 'exclude',
      value: function exclude(expression) {
        return this.clone({ predicate: getExcludePredicate(expression) });
      }
    }, {
      key: 'sort',
      value: function sort(sortComparator) {
        return this.clone({ sortComparator: sortComparator });
      }
    }, {
      key: 'orderBy',
      value: function orderBy() {
        return this.sort(sortBy.apply(undefined, arguments));
      }
    }, {
      key: 'reverse',
      value: function reverse() {
        return this.clone({ sortComparator: function sortComparator() {
            return REVERSED;
          } });
      }
    }, {
      key: 'none',
      value: function none() {
        return this.clone(null, withNonEntriesGenerator(this.QuerySetConstructor));
      }
    }, {
      key: 'all',
      value: function all() {
        return this.clone();
      }
    }]);
    return _class2;
  }(Base);
};

module.exports = {
  withQueries: withQueries,
  getFilterPredicate: getFilterPredicate,
  getExcludePredicate: getExcludePredicate
};
