'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ulid = require('ulid');
var assert = require('./assert');

var Transaction = function () {
  function Transaction(_ref) {
    var values = _ref.values,
        setup = _ref.setup;
    (0, _classCallCheck3.default)(this, Transaction);

    this.values = values;
    this.idKey = setup.get('primaryKeyName');
  }

  (0, _createClass3.default)(Transaction, [{
    key: 'syncNew',
    value: function syncNew(values) {
      var id = ulid();
      var newValues = values.set(this.idKey, id);

      this.values = this.values.set(id, newValues);

      return newValues;
    }
  }, {
    key: 'syncExisting',
    value: function syncExisting(values) {
      var id = values.get(this.idKey);

      assert.entryExists(this, id);

      if (values !== this.values.get(id)) {
        this.values = this.values.set(id, values);
      }

      return values;
    }
  }, {
    key: 'sync',
    value: function sync(values) {
      return values.has(this.idKey) ? this.syncExisting(values) : this.syncNew(values);
    }
  }, {
    key: 'unsync',
    value: function unsync(values) {
      this.values = this.values.remove(values.get(this.idKey));
      return values.remove(this.idKey);
    }
  }]);
  return Transaction;
}();

module.exports = {
  Transaction: Transaction
};
